using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text.RegularExpressions;
using kuzminIVProjectWorkOnDemo.Models;
using ReactiveUI;

namespace kuzminIVProjectWorkOnDemo.ViewModels
{
	public class ClientZapisWindowViewModel : ReactiveObject
	{
        KuzmintestprojContext db;

        Sevicesandclient sevicesandclient;

        string durationServices, timeStart, timeEnd;

        public ClientZapisWindowViewModel(KuzmintestprojContext db)
        {
            this.db = db;

            sevicesandclient = new Sevicesandclient();

            sevicesandclient.Dateoflesson = new DateTime(DateTime.Now.Year, DateTime.Now.Month, DateTime.Now.Day);
        }

        public List<Sevice> ServiceList { get { return db.Sevices.ToList(); } }

        public List<User> UsersList { get { return db.Users.ToList(); } }

        public Sevice takenService { get => sevicesandclient.IdtitleNavigation; set { sevicesandclient.IdtitleNavigation = value; DurationService(); } }

        public User takenUser { get => sevicesandclient.IduserNavigation; set { sevicesandclient.IduserNavigation = value; } }

        public string TimeStart { get => timeStart; set { timeStart = value; MathDurationTime(); } }

        public string TimeEnd { get => timeEnd; set { this.RaiseAndSetIfChanged(ref timeEnd, value); } }

        public string DurationServices { get => durationServices; set { this.RaiseAndSetIfChanged(ref durationServices, value); MathDurationTime(); } }

        public DateTimeOffset DateOfService
        {
            get => new DateTimeOffset((DateTime)sevicesandclient.Dateoflesson, TimeSpan.Zero);

            set => sevicesandclient.Dateoflesson = new DateTime(value.Year, value.Month, value.Day);
        }

        void DurationService()
        {
            if(takenService != null)
            {
                int Minutes = (int)takenService.Duration / 60;
                DurationServices = Minutes.ToString();
            }

        }

        void MathDurationTime()
        {
            if(TimeStart != null && DurationServices != null && Regex.IsMatch(TimeStart, "^([0-1]?[0-9]|2[0-3]):[0-5][0-9]$"))
            {
                int hours = Convert.ToInt32(TimeStart.Substring(0, 2));

                int minutes = Convert.ToInt32(TimeStart.Substring(3, 2));

                TimeSpan timeEndd = new TimeSpan(hours, minutes, 0);

                timeEndd += TimeSpan.FromMinutes(Convert.ToDouble(DurationServices));

                TimeEnd = timeEndd.Hours.ToString() + ":" + timeEndd.Minutes.ToString();

                if (TimeEnd.Length == 4)
                {
                    TimeEnd += "0";

                }
            }
        }

        public void SaveData()
        {
            if (TimeStart != null && takenService != null && takenUser != null && Regex.IsMatch(TimeStart, "^([0-1]?[0-9]|2[0-3]):[0-5][0-9]$"))
            {
                int hours = Convert.ToInt32(TimeStart.Substring(0, 2));

                int minutes = Convert.ToInt32(TimeStart.Substring(3, 2));

                sevicesandclient.Dateoflesson = (DateTime)sevicesandclient.Dateoflesson.Value.AddHours(hours);
                sevicesandclient.Dateoflesson = (DateTime)sevicesandclient.Dateoflesson.Value.AddMinutes(minutes);

                db.Sevicesandclients.Add(sevicesandclient);
                db.SaveChanges();
            }
        }

    }
}